/*! =======================================================
 * Table of Contents - JQuery Plugin
 *
 *       Repo : https://github.com/e2xist/jquery-sh-table-of-contents
 *    Version : 1.0.1
 *     Author : Hong seok-hoon (e2xist)
 *   Requires : jquery 1.9.1 or later
 *   Modified : 2017-03-07
======================================================= */
(function($) {
	//methods
	var methods = {
		init : function($this,options){
				var contents_el = options.contents;
				var optional = (typeof options.optional === "undefined") ? "h1,h2,h3,h4,h5,h6" : options.optional;
				var attr_atemp = options.details.data_temp_anchor_name;
				var secure_optional;

				//optional 처리. (h1-h6)
				var temp_opts = optional.split(",");
				var temp_opts2 = [];
				for(var i in temp_opts){
					var item = temp_opts[i];
					if(item=="h1"||item=="h2"||item=="h3"
					||item=="h4"||item=="h5"||item=="h6"){
						temp_opts2[temp_opts2.length] = item;
					}
				}
				secure_optional = temp_opts2.join(",");

				// create link anchor tag of contents section
				$(contents_el).find(secure_optional).each(function(i){
					var a_temp_name = options.details.anchor_temp_prefix + "-"+$(this).prop("tagName")+"-"+i;
					$(this).prepend("<a name='"+a_temp_name+"' href='#'></a>");
					$(this).attr(attr_atemp,a_temp_name);
				});

				// new elements of toc
				var temp = $(contents_el).find(secure_optional).map(function(){
					var tagName = $(this).prop("tagName");
					return $("<" + tagName + "></" + tagName + ">").text($(this).text()).wrapInner("<span></span>").attr(attr_atemp,$(this).attr(attr_atemp));
					//return this;
				});
				$this.html(temp.get());

				//ul li 생성
				for(var i=6;i>0;i--){
					$this.find("h"+i).each(function(){
						$(this).prev("h"+(i-1)).append($(this).get());
					});
					$this.find("h"+(i-1)+">h"+i).each(function(){
						$(this).wrapAll("<ul></ul>").wrap("<li></li>");
					});
				}

				/*
				숫자 를 붙임
				*/
				numbering($this,1,"");
				function numbering($el,depth,numstr)
				{
					if(depth>6) return;
					if($el.find("h"+depth).length==0)
					{
						return numbering($el,depth+1,"");
					}
					$el.find("h"+depth).each(function(i){
						var numbered = numstr + (i+1) + ".";
						var linkname_list = options.details.anchor_prefix_of_toc + "-" + numstr + (i+1);
						var linkname_item = options.details.anchor_prefix_of_contents + "-" + numstr + (i+1);

						// assign numberstring in toc section
						var link = $("<a></a>").attr("href","#"+linkname_item).text(numbered).attr("name",linkname_list);
						$(this).prepend(" ").prepend(link);

						// assign numberstring in contents section
						$(contents_el).find("a[name='"+$(this).attr(attr_atemp)+"']").text(numbered).attr("href","#"+linkname_list).attr("name",linkname_item);

						//recursive call
						return numbering($(this),depth+1,numbered);
					});
				}

				//create anchor tag
				$(contents_el).find(secure_optional).removeAttr(attr_atemp);
				$this.find(secure_optional).removeAttr(attr_atemp);
		},
		//debug messages
		debug: function(options, message){
			if(window.console && window.console.log && options.debug)
			{
				console.log("[JQueryTOC]"+message);
			}
		}
	};

	$.extend($.fn, {
		shTableOfContents : function(options)
		{
			//set default options
			var defaults = {
				contents : "",
				details : {
					anchor_temp_prefix : "shtoc-tp-list-item",
					data_temp_anchor_name : "data-temp-aname",
					anchor_prefix_of_toc : "shtoc-list",
					anchor_prefix_of_contents : "shtoc-item"
				},
				debug:false
			};
			
			//merge options
			if(typeof options === 'object'){
				if(typeof options.details === 'object'){
					options.details = $.extend({}, defaults.details, options.details);
				}
				options = $.extend({}, defaults, options);
				methods.debug(options,"merge Options");
			} else {
				options = defaults;
			}

			//nothing selected
			if(!this.length && options.debug)
			{
				methods.debug(options,"Object is null");
				return false;
			}

			//call method init
			$(this).prepend("<div></div>");
			methods.init($(this).children("div").first(),options);

			return this;
		}
	});
}(jQuery));